// import { BinaryStreamReader } from "./readerStream";
// import { AsyncReadMethod, AsyncReadMethodReturnValue, ObjectValue, ObjectValueType, ReadMethod, ReadMethodReturnValue } from "./types";

// export class BinaryReader {
//   protected index: number = 0;

//   constructor(
//     protected readonly buffer: DataView,
//   ) {}

//   readBoolean(): boolean {
//     return this.readUInt8() != 0;
//   }

//   readSInt8(): number {
//     const value = this.buffer.getInt8(this.index);

//     this.index++;

//     return value;
//   }

//   readUInt8(): number {
//     const value = this.buffer.getUint8(this.index);

//     this.index++;

//     return value;
//   }

//   readSInt16(): number {
//     const value = this.buffer.getInt16(this.index, true);

//     this.index += 2;

//     return value;
//   }

//   readUInt16(): number {
//     const value = this.buffer.getUint16(this.index, true);

//     this.index += 2;

//     return value;
//   }

//   readSInt32(): number {
//     const value = this.buffer.getInt32(this.index, true);

//     this.index += 4;

//     return value;
//   }

//   readUInt32(): number {
//     const value = this.buffer.getUint32(this.index, true);

//     this.index += 4;

//     return value;
//   }

//   readSInt64(): bigint {
//     const value = this.buffer.getBigInt64(this.index, true);

//     this.index += 8;

//     return value;
//   }

//   readUInt64(): bigint {
//     const value = this.buffer.getBigUint64(this.index, true);

//     this.index += 8;

//     return value;
//   }

//   readFloat32(): number {
//     const value = this.buffer.getFloat32(this.index, true);

//     this.index += 4;

//     return value;
//   }

//   readFloat64(): number {
//     const value = this.buffer.getFloat64(this.index, true);

//     this.index += 8;

//     return value;
//   }

//   readString(length: number, encoding?: string): string {
//     const decoder = new TextDecoder(encoding);

//     return decoder.decode(this.buffer.buffer.slice(this.index, this.index += length));
//   }

//   async readArray<T>(size: number, readMethod: ReadMethod<T> | AsyncReadMethod<T>): Promise<T[]> {
//     const array = new Array<T>(size);

//     for (let i = 0; i < size; i++) {
//       array[i] = await this.read(readMethod);
//     }

//     return array;
//   }

//   async readObject(): Promise<ObjectValue> {
//     return await this.readMappedShortEnum({
//       [ObjectValueType.Object]: async (r: BinaryReader | BinaryStreamReader) => Object.fromEntries(await r.readArray(await r.readUInt32(), async r2 => [ await r2.readString(await r2.readUInt32()), await r2.readObject() ])),
//       [ObjectValueType.Array]: async (r: BinaryReader | BinaryStreamReader) => await r.readArray(await r.readUInt32(), async (r2: BinaryReader | BinaryStreamReader) => await r2.readObject()),
//       [ObjectValueType.Boolean]: async (r: BinaryReader | BinaryStreamReader) => await r.readBoolean(),
//       [ObjectValueType.Null]: () => null,
//       [ObjectValueType.Number]: async (r: BinaryReader | BinaryStreamReader) => await r.readFloat64(),
//       [ObjectValueType.String]: async (r: BinaryReader | BinaryStreamReader) => await r.readString(await r.readUInt32()),
//     })
//   }

//   async read<T>(readMethod: ReadMethod<T> | AsyncReadMethod<T>): Promise<T> {
//     if ("deserialize" in readMethod) {
//       return await readMethod.deserialize(this);
//     }

//     return await readMethod(this);
//   }

//   readShortEnum<T extends number>(): T {
//     return this.readUInt8() as T;
//   }

//   readEnum<T extends number>(): T {
//     return this.readUInt16() as T;
//   }

//   readDate(): Date {
//     return new Date(Number(this.readUInt64()));
//   }

//   async readMappedEnum<T extends number, R extends Record<T, ReadMethod<any> | AsyncReadMethod<T>>>(mappedType: R): Promise<ReadMethodReturnValue<R[keyof R]> | AsyncReadMethodReturnValue<R[keyof R]>> {
//     return await this.read(mappedType[this.readEnum<T>()]);
//   }

//   async readMappedShortEnum<T extends number, R extends Record<T, ReadMethod<any> | AsyncReadMethod<T>>>(mappedType: R): Promise<ReadMethodReturnValue<R[keyof R]> | AsyncReadMethodReturnValue<R[keyof R]>> {
//     return await this.read(mappedType[this.readShortEnum<T>()]);
//   }
// }
