import { BinaryStreamReader } from "../binary/readerStream";
import { Player } from "../client.svelte";

export async function readHello(reader: BinaryStreamReader) {
  console.log("reading");
  const count = await reader.readUInt8();
  console.log("reading", count);
  const players = await reader.readArray(count, async (reader) => {
    const name = await reader.readFixedString(0x20);
    console.log(name);
    const id = await reader.readUInt32();
    const position = await reader.readArray(3, async reader => await reader.readFloat32());
    const stage = await reader.readFixedString(0x40);

    return new Player(
      name,
      id,
      position,
      stage,
    );
  });

  return players;
}
